from django.db import models

from gauth.models import Location


class Staff(models.Model):
    name = models.CharField(max_length=255)
    total_units = models.FloatField()
    location = models.ForeignKey(Location, on_delete=models.CASCADE)
    nick_names = models.TextField()

    def __str__(self):
        return f'{self.name} - {self.location}'

    @property
    def get_nick_names(self):
        return self.nick_names.split(',')

